Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 26744)
@@ -5582,398 +6577,1147 @@
 	}
 	#endif
-
+	/*}}}*/
 	return;
-}
-/*}}}*/
-IssmDouble Tria::SealevelriseEustaticIce(IssmDouble* Sgi, SealevelMasks* masks, Vector<IssmDouble>* barystatic_contribution, IssmDouble* partition, IssmDouble oceanarea){ /*{{{*/
-
-	/*diverse:*/
-	int gsize;
+
+}
+/*}}}*/
+void       Tria::SealevelchangeGeometryCentroidLoads(SealevelGeometry* slgeom, IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae){ /*{{{*/
+
+	/* Classic buildup of load weights, centroids and areas *for elements which are fully inside a mask. 
+	 * At the same time, we'll tag the elements that are fractionally only inside a mask*/
+
+	IssmDouble loadweights[3]={0};
 	IssmDouble area;
-	IssmDouble phi=1.0; //WARNING: do not touch this, default is entire elemnt contributes eustatic
-	IssmDouble I;  //change in ice thickness or water level(Farrel and Clarke, Equ. 4)
-	bool notfullygrounded=false;
-	bool scaleoceanarea= false;
-	bool computerigid= false;
-	int  glfraction=1;
-
-	/*output: */
-	IssmDouble bslrice=0;
-
-	/*elastic green function:*/
-	IssmDouble* G=NULL;
-
-	/*ice properties: */
-	IssmDouble rho_ice,rho_water;
+	IssmDouble loadweightsocean[3]; //to keep memory of these loads, no need to recompute for bottom pressure.
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble planetradius;
+	IssmDouble late,longe;
+
+	/*flags:*/
+	bool isocean=false;
+	bool isoceanonly=false;
+	bool isice=false;
+	bool isiceonly=false;
+	bool  computeice=false;
+	bool  computebp=false;
+	bool  computehydro=false;
 
 	/*constants:*/
 	IssmDouble constant=0;
 
-	/*early return if we are not on an ice cap:*/
-	if(!masks->isiceonly[this->lid]){
+	/*recover parameters:*/
+	this->parameters->FindParam(&computeice,TransientIsmasstransportEnum);
+	this->parameters->FindParam(&computebp,TransientIsoceantransportEnum);
+	this->parameters->FindParam(&computehydro,TransientIshydrologyEnum);
+	this->parameters->FindParam(&planetradius,SolidearthPlanetRadiusEnum);
+
+	/*get vertex information:*/
+	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
+
+	/*answer mask questions:*/
+	isiceonly=this->IsIceOnlyInElement();
+	isice=this->IsIceInElement();
+	isoceanonly=this->IsOceanOnlyInElement();
+	isocean=this->IsOceanInElement();
+	slgeom->isoceanin[this->lid]=isocean; //keep track for later.
+	area=areae[this->sid];
+
+	/*Compute element ids, used to speed up computations in convolution phase:{{{*/
+	for(int i=0;i<NUMVERTICES;i++){
+		slgeom->lids[this->vertices[i]->lid]=this->lid;
+	}
+	/*}}}*/
+
+	/*set barycentre for all elements, to be updated for fractional loads in the next routine: */
+	//late= asin(zze[this->sid]/planetradius)*180.0/M_PI;
+	late= asin(zze[this->sid]/sqrt( pow(xxe[this->sid],2.0)+ pow(yye[this->sid],2.0)+ pow(zze[this->sid],2.0)))*180.0/M_PI;
+	longe= atan2(yye[this->sid],xxe[this->sid])*180.0/M_PI;
+	slgeom->longe[this->lid]=longe;
+	slgeom->late[this->lid]=late;
+
+	/*compute areas and load weights for ocean and flag elements only partially in the ocean:*/
+	if(isoceanonly){ 
+		slgeom->LoadArea[SLGEOM_OCEAN][this->lid]=area;
+		for(int i=0;i<NUMVERTICES;i++) slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid]=1.0/3.0;
+
+		#ifdef _ISSM_DEBUG_ /*{{{*/
+		/*Inform mask: */
+		constant=1.0;
+		for(int i=0;i<NUMVERTICES;i++) loadweightsocean[i]=1.0/3.0;
+		this->AddInput(SealevelBarystaticOceanMaskEnum,&constant,P0Enum); 
+		this->AddInput(SealevelBarystaticOceanWeightsEnum,loadweightsocean,P1DGEnum);
+		this->AddInput(SealevelBarystaticOceanAreaEnum,&area,P0Enum);
+		#endif /*}}}*/
+	}
+	else if(!isocean){
+		slgeom->LoadArea[SLGEOM_OCEAN][this->lid]=0;
+		for(int i=0;i<NUMVERTICES;i++) slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid]=0.0;
+		#ifdef _ISSM_DEBUG_ /*{{{*/
+		/*Inform mask: */
+		constant=0.0;
+		for(int i=0;i<NUMVERTICES;i++) loadweightsocean[i]=0.0;
+		this->AddInput(SealevelBarystaticOceanMaskEnum,&constant,P0Enum); 
+		this->AddInput(SealevelBarystaticOceanWeightsEnum,loadweightsocean,P1DGEnum);
+		this->AddInput(SealevelBarystaticOceanAreaEnum,&constant,P0Enum);
+		#endif /*}}}*/
+	}
+	else{
+		slgeom->issubelement[SLGEOM_OCEAN][this->lid]=true;
+		slgeom->nsubel[SLGEOM_OCEAN]++;
+	}
+
+	/*early return if we are not on an ice sheet , and we are not requesting 
+	 *hydrology or bottom pressure loads :*/
+	if(!computebp && !computehydro){
+		if(!isice  || isoceanonly) {
+			#ifdef _ISSM_DEBUG_
+			constant=0; 
+			this->AddInput(SealevelBarystaticIceMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticIceAreaEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticIceWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticHydroMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticHydroWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticHydroAreaEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticBpMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticBpWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticBpAreaEnum,&constant,P0Enum);
+			#endif
+			for(int i=0;i<NUMVERTICES;i++){
+				slgeom->LoadWeigths[SLGEOM_ICE][i][this->lid]=0;
+				slgeom->LoadWeigths[SLGEOM_WATER][i][this->lid]=0;
+			}
+			slgeom->LoadArea[SLGEOM_ICE][this->lid]=0;
+			slgeom->LoadArea[SLGEOM_WATER][this->lid]=0;
+			return;
+		}
+	}
+
+	/*early return if we are fully floating and we are not doing bottom pressure loads:*/
+	if(!computebp){
+		if (isoceanonly){
+			#ifdef _ISSM_DEBUG_
+			constant=0;
+			this->AddInput(SealevelBarystaticIceMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticIceWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticIceAreaEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticHydroMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticHydroWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticHydroAreaEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticBpMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticBpWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticBpAreaEnum,&constant,P0Enum);
+			#endif
+			for(int i=0;i<NUMVERTICES;i++){
+				slgeom->LoadWeigths[SLGEOM_ICE][i][this->lid]=0;
+				slgeom->LoadWeigths[SLGEOM_WATER][i][this->lid]=0;
+			}
+			slgeom->LoadArea[SLGEOM_ICE][this->lid]=0;
+			slgeom->LoadArea[SLGEOM_WATER][this->lid]=0;
+			return;
+		}
+	}
+
+	/*early return if we are not on the ocean and we are not doing ice mass transport of 
+	 * hydrology:*/
+	if(!computeice  && !computehydro){
+		if(!isocean){
+			#ifdef _ISSM_DEBUG_
+			constant=0;
+			this->AddInput(SealevelBarystaticIceMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticIceWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticIceAreaEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticHydroMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticHydroWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticHydroAreaEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticBpMaskEnum,&constant,P0Enum);
+			this->AddInput(SealevelBarystaticBpWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticBpAreaEnum,&constant,P0Enum);
+			#endif
+			for(int i=0;i<NUMVERTICES;i++){
+				slgeom->LoadWeigths[SLGEOM_ICE][i][this->lid]=0;
+				slgeom->LoadWeigths[SLGEOM_WATER][i][this->lid]=0;
+			}
+			slgeom->LoadArea[SLGEOM_ICE][this->lid]=0;
+			slgeom->LoadArea[SLGEOM_WATER][this->lid]=0;
+			return;
+		}
+	}
+
+	/*Deal with ice loads if we are on grounded ice:*/
+	if(isice && !isoceanonly && computeice){
+		if(isiceonly && !isocean){
+			slgeom->LoadArea[SLGEOM_ICE][this->lid]=area;
+			for(int i=0;i<NUMVERTICES;i++) slgeom->LoadWeigths[SLGEOM_ICE][i][this->lid]=1.0/3.0;
+
+			#ifdef _ISSM_DEBUG_ /*{{{*/
+			/*Inform mask: */
+			constant=1.0;
+			for(int i=0;i<NUMVERTICES;i++) loadweights[i]=1.0/3.0;
+			this->AddInput(SealevelBarystaticIceMaskEnum,&constant,P0Enum); 
+			this->AddInput(SealevelBarystaticIceWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticIceAreaEnum,&area,P0Enum);
+			#endif /*}}}*/
+		}
+		else{
+			slgeom->issubelement[SLGEOM_ICE][this->lid]=true;
+			slgeom->nsubel[SLGEOM_ICE]++;
+		}
+	} 
+
+	/*Deal with water loads if we are on ground:*/
+	if(!isoceanonly && computehydro){
+
+		if(!isocean){
+			slgeom->LoadArea[SLGEOM_WATER][this->lid]=area;
+			for(int i=0;i<NUMVERTICES;i++) slgeom->LoadWeigths[SLGEOM_WATER][i][this->lid]=1.0/3.0;
+
+			#ifdef _ISSM_DEBUG_ /*{{{*/
+			/*Inform mask: */
+			constant=1.0;
+			for(int i=0;i<NUMVERTICES;i++) loadweights[i]=1.0/3.0;
+			this->AddInput(SealevelBarystaticHydroMaskEnum,&constant,P0Enum); 
+			this->AddInput(SealevelBarystaticHydroWeightsEnum,loadweights,P1DGEnum);
+			this->AddInput(SealevelBarystaticHydroAreaEnum,&area,P0Enum);
+			#endif /*}}}*/
+		}
+		else{
+			slgeom->issubelement[SLGEOM_WATER][this->lid]=true;
+			slgeom->nsubel[SLGEOM_WATER]++;
+		}
+	}
+
+}
+/*}}}*/
+void       Tria::SealevelchangeGeometrySubElementLoads(SealevelGeometry* slgeom, IssmDouble* areae){ /*{{{*/
+
+	/* Classic buildup of load weights, centroids and areas *for elements which are fully inside a mask. 
+	 * At the same time, we'll tag the elements that are fractionally only inside a mask*/
+
+	IssmDouble loadweights[3]={0};
+	IssmDouble area,loadarea;
+	IssmDouble loadareaocean;
+	IssmDouble loadweightsocean[3]; //to keep memory of these loads, no need to recompute for bottom pressure.
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble latbar=slgeom->late[this->lid];
+	IssmDouble longbar=slgeom->longe[this->lid];
+	IssmDouble constant;
+	IssmDouble nanconstant=NAN;
+
+	/*get vertex and area information:*/
+	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
+	area=areae[this->sid];
+
+	#ifdef _ISSM_DEBUG_
+	this->AddInput(SealevelBarystaticIceLatbarEnum,&latbar,P0Enum); 
+	this->AddInput(SealevelBarystaticIceLongbarEnum,&longbar,P0Enum); 
+	this->AddInput(SealevelBarystaticHydroLatbarEnum,&latbar,P0Enum); 
+	this->AddInput(SealevelBarystaticHydroLongbarEnum,&longbar,P0Enum); 
+	this->AddInput(SealevelBarystaticOceanLatbarEnum,&latbar,P0Enum); 
+	this->AddInput(SealevelBarystaticOceanLongbarEnum,&longbar,P0Enum); 
+	#endif
+
+	if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
+
+		this->GetNodalWeightsAndAreaAndCentroidsFromLeveset(&loadweightsocean[0],&loadareaocean,&latbar, &longbar, slgeom->late[this->lid], slgeom->longe[this->lid], area, MaskOceanLevelsetEnum);
+		slgeom->LoadArea[SLGEOM_OCEAN][this->lid]=loadareaocean;
+		slgeom->vareae_subel[SLGEOM_OCEAN]->SetValue(intj,loadareaocean,INS_VAL);
+		slgeom->vlatbarycentre[SLGEOM_OCEAN]->SetValue(intj,latbar,INS_VAL);
+		slgeom->vlongbarycentre[SLGEOM_OCEAN]->SetValue(intj,longbar,INS_VAL);
+
+		for(int i=0;i<NUMVERTICES;i++) slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid]=loadweightsocean[i];
+		#ifdef _ISSM_DEBUG_ /*{{{*/
+		/*Inform mask: */
+		constant=loadareaocean/area;
+		this->AddInput(SealevelBarystaticOceanMaskEnum,&constant,P0Enum); 
+		this->AddInput(SealevelBarystaticOceanWeightsEnum,loadweightsocean,P1DGEnum);
+		this->AddInput(SealevelBarystaticOceanAreaEnum,&loadareaocean,P0Enum);
+
+		this->AddInput(SealevelBarystaticOceanLatbarEnum,&latbar,P0Enum); 
+		this->AddInput(SealevelBarystaticOceanLongbarEnum,&longbar,P0Enum); 
+		#endif /*}}}*/
+	}
+	if(slgeom->issubelement[SLGEOM_ICE][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_ICE][this->lid];
+
+		this->GetNodalWeightsAndAreaAndCentroidsFromLeveset(&loadweights[0],&loadarea,&latbar, &longbar, slgeom->late[this->lid], slgeom->longe[this->lid], area, -MaskOceanLevelsetEnum,MaskIceLevelsetEnum);
+
+		slgeom->LoadArea[SLGEOM_ICE][this->lid]=loadarea;
+		slgeom->vareae_subel[SLGEOM_ICE]->SetValue(intj,loadarea,INS_VAL);
+		slgeom->vlatbarycentre[SLGEOM_ICE]->SetValue(intj,latbar,INS_VAL);
+		slgeom->vlongbarycentre[SLGEOM_ICE]->SetValue(intj,longbar,INS_VAL);
+
+		for(int i=0;i<NUMVERTICES;i++)slgeom->LoadWeigths[SLGEOM_ICE][i][this->lid]=loadweights[i];
+
 		#ifdef _ISSM_DEBUG_
-		constant=0; this->AddInput(SealevelEustaticMaskEnum,&constant,P0Enum);
+		/*Inform mask: */
+		constant=loadarea/area; 
+		this->AddInput(SealevelBarystaticIceMaskEnum,&constant,P0Enum);
+		this->AddInput(SealevelBarystaticIceWeightsEnum,loadweights,P1DGEnum);
+		this->AddInput(SealevelBarystaticIceAreaEnum,&loadarea,P0Enum);
+
+		this->AddInput(SealevelBarystaticIceLatbarEnum,&latbar,P0Enum); 
+		this->AddInput(SealevelBarystaticIceLongbarEnum,&longbar,P0Enum); 
+
 		#endif
-		bslrice=0;
-		return bslrice;
-	}
-
-	/*early return if we are fully floating:*/
-	if (masks->isfullyfloating[this->lid]){
-		constant=0;
+	}
+	if(slgeom->issubelement[SLGEOM_WATER][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_WATER][this->lid];
+
+		this->GetNodalWeightsAndAreaAndCentroidsFromLeveset(&loadweights[0],&loadarea,&latbar, &longbar, slgeom->late[this->lid], slgeom->longe[this->lid], area, -MaskOceanLevelsetEnum);
+
+		slgeom->LoadArea[SLGEOM_WATER][this->lid]=loadarea;
+		slgeom->vareae_subel[SLGEOM_WATER]->SetValue(intj,loadarea,INS_VAL);
+		slgeom->vlatbarycentre[SLGEOM_WATER]->SetValue(intj,latbar,INS_VAL);
+		slgeom->vlongbarycentre[SLGEOM_WATER]->SetValue(intj,longbar,INS_VAL);
+
+		for(int i=0;i<NUMVERTICES;i++)slgeom->LoadWeigths[SLGEOM_WATER][i][this->lid]=loadweights[i];
+
 		#ifdef _ISSM_DEBUG_
-		this->AddInput(SealevelEustaticMaskEnum,&constant,P0Enum);
+		/*Inform mask: */
+		constant=loadarea/area; 
+		this->AddInput(SealevelBarystaticHydroMaskEnum,&constant,P0Enum);
+		this->AddInput(SealevelBarystaticHydroWeightsEnum,loadweights,P1DGEnum);
+		this->AddInput(SealevelBarystaticHydroAreaEnum,&loadarea,P0Enum);
+
+		this->AddInput(SealevelBarystaticHydroLatbarEnum,&latbar,P0Enum); 
+		this->AddInput(SealevelBarystaticHydroLongbarEnum,&longbar,P0Enum); 
+
 		#endif
-		bslrice=0;
-		return bslrice;
-	}
-
-	/*If we are here, we are on ice that is fully grounded or half-way to floating:*/
-	if (masks->notfullygrounded[this->lid]) notfullygrounded=true; //used later on.
-
-	/*Inform mask: */
-	constant=1;
-	#ifdef _ISSM_DEBUG_
-	this->AddInput(SealevelEustaticMaskEnum,&constant,P0Enum);
+	}
+
+}
+/*}}}*/
+void       Tria::SealevelchangeGeometrySubElementKernel(SealevelGeometry* slgeom){ /*{{{*/
+
+	/*Declarations:{{{*/
+	int nel;
+	IssmDouble planetarea,planetradius;
+	IssmDouble constant,ratioe;
+	IssmDouble rho_earth;
+	IssmDouble lati,longi;
+	IssmDouble latitude[NUMVERTICES];
+	IssmDouble longitude[NUMVERTICES];
+	IssmDouble x,y,z,dx,dy,dz,N_azim,E_azim;
+	IssmDouble xyz_list[NUMVERTICES][3];
+
+	#ifdef _HAVE_RESTRICT_
+	IssmDouble* __restrict__ G_viscoelastic_precomputed=NULL;
+	IssmDouble* __restrict__ G_gravi_precomputed=NULL;
+	IssmDouble* __restrict__ U_viscoelastic_precomputed=NULL;
+	IssmDouble* __restrict__ H_viscoelastic_precomputed=NULL;
+	IssmDouble** __restrict__ Gsubel=NULL;
+	IssmDouble** __restrict__ GUsubel=NULL;
+	IssmDouble** __restrict__ GNsubel=NULL;
+	IssmDouble** __restrict__ GEsubel=NULL;
+
+	#else
+	IssmDouble* G_viscoelastic_precomputed=NULL;
+	IssmDouble* G_gravi_precomputed=NULL;
+	IssmDouble* U_viscoelastic_precomputed=NULL;
+	IssmDouble* H_viscoelastic_precomputed=NULL;
+	IssmDouble** Gsubel=NULL;
+	IssmDouble** GUsubel=NULL;
+	IssmDouble** GNsubel=NULL;
+	IssmDouble** GEsubel=NULL;
 	#endif
 
+	/*viscoelastic green function:*/
+	int index;
+	int M;
+	IssmDouble doubleindex,lincoef;
+
+	/*Computational flags:*/
+	bool computeselfattraction = false;
+	bool computeelastic = false;
+	bool computeviscous = false;
+	int  horiz;
+	int grd, grdmodel;
+
+	bool istime=true;
+	IssmDouble timeacc=0;
+	IssmDouble start_time,final_time;
+	int  nt,precomputednt;
+
+	/*}}}*/
+	/*Recover parameters:{{{ */
+	rho_earth=FindParam(MaterialsEarthDensityEnum);
+	this->parameters->FindParam(&computeselfattraction,SolidearthSettingsSelfAttractionEnum);
+	this->parameters->FindParam(&computeelastic,SolidearthSettingsElasticEnum);
+	this->parameters->FindParam(&computeviscous,SolidearthSettingsViscousEnum);
+	this->parameters->FindParam(&nel,MeshNumberofelementsEnum);
+	this->parameters->FindParam(&planetarea,SolidearthPlanetAreaEnum);
+	this->parameters->FindParam(&planetradius,SolidearthPlanetRadiusEnum);
+	this->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
+	this->parameters->FindParam(&grd,SolidearthSettingsGRDEnum); 
+	this->parameters->FindParam(&grdmodel,GrdModelEnum);
+	/*}}}*/
+
+	/*early return:*/
+	if (!grd || grdmodel!=ElasticEnum) return; //Love numbers won't be found in this case, return before loading them
+	if(!computeselfattraction)return;
+
+	/*Recover precomputed green function kernels:{{{*/
+	DoubleVecParam* parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGSelfAttractionEnum)); _assert_(parameter);
+	parameter->GetParameterValueByPointer((IssmDouble**)&G_gravi_precomputed,&M);
+
+	if(computeelastic){
+		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGViscoElasticEnum)); _assert_(parameter);
+		parameter->GetParameterValueByPointer((IssmDouble**)&G_viscoelastic_precomputed,NULL);
+
+		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeUViscoElasticEnum)); _assert_(parameter);
+		parameter->GetParameterValueByPointer((IssmDouble**)&U_viscoelastic_precomputed,NULL);
+
+		if(horiz){
+			parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeHViscoElasticEnum)); _assert_(parameter);
+			parameter->GetParameterValueByPointer((IssmDouble**)&H_viscoelastic_precomputed,NULL);
+
+		}
+	}
+	/*}}}*/
+	/*Compute lat long of all vertices in the element:{{{*/
+	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
+	for(int i=0;i<NUMVERTICES;i++){
+		latitude[i]= asin(xyz_list[i][2]/planetradius);
+		longitude[i]= atan2(xyz_list[i][1],xyz_list[i][0]);
+	}
+	/*}}}*/
+	/*Compute green functions:{{{ */
+	constant=3/rho_earth/planetarea;
+
+	if(computeviscous){
+		this->parameters->FindParam(&istime,LoveIsTimeEnum);
+		if(!istime)_error_("Frequency love numbers not supported yet!");
+		this->parameters->FindParam(&timeacc,SolidearthSettingsTimeAccEnum);
+		this->parameters->FindParam(&start_time,TimesteppingStartTimeEnum);
+		this->parameters->FindParam(&final_time,TimesteppingFinalTimeEnum);
+		nt=reCast<int,IssmDouble>((final_time-start_time)/timeacc)+1;
+	}
+	else{
+		nt=1; //in elastic, or if we run only selfattraction, we need only one step
+	}
+	Gsubel=xNew<IssmDouble*>(SLGEOM_NUMLOADS);
+	if(computeelastic){
+		GUsubel=xNew<IssmDouble*>(SLGEOM_NUMLOADS);
+		if(horiz){
+			GNsubel=xNew<IssmDouble*>(SLGEOM_NUMLOADS);
+			GEsubel=xNew<IssmDouble*>(SLGEOM_NUMLOADS);
+		}
+	}
+
+	//Allocate: 
+	for(int l=0;l<SLGEOM_NUMLOADS;l++){
+		int nbar=slgeom->nbar[l];
+		Gsubel[l]=xNewZeroInit<IssmDouble>(3*nbar*nt);
+		if(computeelastic){
+			GUsubel[l]=xNewZeroInit<IssmDouble>(3*nbar*nt);
+			if(horiz){
+				GNsubel[l]=xNewZeroInit<IssmDouble>(3*nbar*nt);
+				GEsubel[l]=xNewZeroInit<IssmDouble>(3*nbar*nt);
+			}
+		}
+
+		for(int e=0;e<nbar;e++){
+			ratioe=constant*slgeom->area_subel[l][e];
+			for (int i=0;i<3;i++){
+				IssmDouble alpha;
+				IssmDouble delPhi,delLambda;
+				/*recover info for this element and vertex:*/
+				IssmDouble late= slgeom->latbarycentre[l][e]; 
+				IssmDouble longe= slgeom->longbarycentre[l][e]; 
+				late=late/180*M_PI;
+				longe=longe/180*M_PI;
+
+				lati=latitude[i];
+				longi=longitude[i];
+
+				if(horiz){
+					/*Compute azimuths, both north and east components: */
+					x = xyz_list[i][0]; y = xyz_list[i][1]; z = xyz_list[i][2];
+					if(lati==90){
+						x=1e-12; y=1e-12;
+					}
+					if(lati==-90){
+						x=1e-12; y=1e-12;
+					}
+					IssmDouble xbar=planetradius*cos(late)*cos(longe);
+					IssmDouble ybar=planetradius*cos(late)*sin(longe);
+					IssmDouble zbar=planetradius*sin(late);
+
+					dx = xbar-x; dy = ybar-y; dz = zbar-z;
+					N_azim = (-z*x*dx-z*y*dy+(pow(x,2)+pow(y,2))*dz) /pow((pow(x,2)+pow(y,2))*(pow(x,2)+pow(y,2)+pow(z,2))*(pow(dx,2)+pow(dy,2)+pow(dz,2)),0.5);
+					E_azim = (-y*dx+x*dy) /pow((pow(x,2)+pow(y,2))*(pow(dx,2)+pow(dy,2)+pow(dz,2)),0.5);
+				}
+
+				/*Compute alpha angle between centroid and current vertex and index into precomputed tables: */
+				delPhi=fabs(lati-late); delLambda=fabs(longi-longe); if (delLambda>M_PI)delLambda=2*M_PI-delLambda;
+				alpha=2.*asin(sqrt(pow(sin(delPhi/2.0),2.0)+cos(lati)*cos(late)*pow(sin(delLambda/2.0),2.0)));
+				doubleindex=alpha/M_PI*reCast<IssmDouble,int>(M-1); //maps 0<alpha<PI on [0:M-1]
+				index=reCast<int,IssmDouble>(doubleindex); //truncates doubleindex to integer part
+
+				lincoef=doubleindex-index; //where between index and index+1 is alpha
+				if (index==M-1){ //avoids out of bound case
+					index-=1;
+					lincoef=1;
+				}
+
+				for(int t=0;t<nt;t++){
+					int timeindex=i*nbar*nt+e*nt+t; 
+
+					/*Rigid earth gravitational perturbation: */
+					Gsubel[l][timeindex]+=G_gravi_precomputed[index+0]*(1.-lincoef) 
+					    		     +G_gravi_precomputed[index+1]*lincoef; //linear interpolation
+
+					if(computeelastic){
+						Gsubel[l][timeindex]+=G_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
+								     +G_viscoelastic_precomputed[(index+1)*nt+t]*lincoef; //linear interpolation
+					}
+					Gsubel[l][timeindex]*=ratioe;
+
+					/*Elastic components:*/
+					if(computeelastic){
+						GUsubel[l][timeindex] =  ratioe *(U_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
+										 +U_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
+						if(horiz){
+							GNsubel[l][timeindex] = N_azim*ratioe *(H_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
+								 			      +H_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
+							GEsubel[l][timeindex] = E_azim*ratioe *(H_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
+								 			      +H_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
+						}
+					}
+				}
+			}
+		}
+	}
+
+	/*Save all these arrayins for each element:*/
+	for (int l=0;l<SLGEOM_NUMLOADS;l++){
+		this->inputs->SetArrayInput(slgeom->GEnum(l),this->lid,Gsubel[l],slgeom->nbar[l]*3*nt);
+		if(computeelastic){
+			this->inputs->SetArrayInput(slgeom->GUEnum(l),this->lid,GUsubel[l],slgeom->nbar[l]*3*nt);
+			if(horiz){
+				this->inputs->SetArrayInput(slgeom->GNEnum(l),this->lid,GNsubel[l],slgeom->nbar[l]*3*nt);
+				this->inputs->SetArrayInput(slgeom->GEEnum(l),this->lid,GEsubel[l],slgeom->nbar[l]*3*nt);
+			}
+		}
+	}
+	/*}}}*/
+	/*Free memory:{{{*/
+	for (int l=0;l<SLGEOM_NUMLOADS;l++){
+		xDelete<IssmDouble>(Gsubel[l]);
+		if(computeelastic){
+			xDelete<IssmDouble>(GUsubel[l]);
+			if(horiz){
+				xDelete<IssmDouble>(GNsubel[l]);
+				xDelete<IssmDouble>(GEsubel[l]);
+			}
+		}
+	}
+	xDelete<IssmDouble*>(Gsubel);
+	if(computeelastic){
+		xDelete<IssmDouble*>(GUsubel);
+		if(horiz){
+			xDelete<IssmDouble*>(GNsubel); 
+			xDelete<IssmDouble*>(GEsubel);
+		}
+	}
+	/*}}}*/
+	return;
+
+}
+/*}}}*/
+void       Tria::SealevelchangeUpdateViscousFields(){ /*{{{*/
+
+	/*Inputs:*/
+	IssmDouble* viscousRSL=NULL;
+	IssmDouble* viscousU=NULL;
+	IssmDouble* viscousN=NULL;
+	IssmDouble* viscousE=NULL;
+	IssmDouble* viscoustimes=NULL;
+	int         viscousnumsteps;
+	int         viscousindex=0; 
+	int         newindex=0; 
+	int         dummy;
+	bool        viscous=false;
+	IssmDouble  currenttime;
+	IssmDouble  lincoeff=0;
+	int horiz;
+
+	this->parameters->FindParam(&viscous,SolidearthSettingsViscousEnum);
+
+	if(viscous){
+		this->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
+
+		this->parameters->FindParam(&viscousnumsteps,SealevelchangeViscousNumStepsEnum);
+		this->parameters->FindParam(&viscoustimes,NULL,SealevelchangeViscousTimesEnum);
+		this->parameters->FindParam(&viscousindex,SealevelchangeViscousIndexEnum);
+		this->parameters->FindParam(&currenttime,TimeEnum);
+
+		this->inputs->GetArrayPtr(SealevelchangeViscousRSLEnum,this->lid,&viscousRSL,&dummy);
+		this->inputs->GetArrayPtr(SealevelchangeViscousUEnum,this->lid,&viscousU,&dummy);
+		if(horiz){
+			this->inputs->GetArrayPtr(SealevelchangeViscousNEnum,this->lid,&viscousN,&dummy);
+			this->inputs->GetArrayPtr(SealevelchangeViscousEEnum,this->lid,&viscousE,&dummy);
+		}
+
+		bool foundtime=false;
+		int offset=1;
+		lincoeff=0;
+		newindex=viscousnumsteps-2;
+
+		for(int t=viscousindex;t<viscousnumsteps;t++){
+			if (viscoustimes[t]>currenttime){
+				newindex=t-1;
+				lincoeff=(currenttime-viscoustimes[newindex])/(viscoustimes[t]-viscoustimes[newindex]);
+				foundtime=true;
+				offset=0;
+				break;
+			}
+		}
+
+		if(!foundtime) lincoeff=1;
+		viscoustimes[newindex]=currenttime;
+		for(int i=0;i<NUMVERTICES;i++){
+			viscousRSL[i*viscousnumsteps+newindex+offset]=(1-lincoeff)*viscousRSL[i*viscousnumsteps+newindex]+lincoeff*viscousRSL[i*viscousnumsteps+newindex+1];
+			viscousU[i*viscousnumsteps+newindex+offset]=(1-lincoeff)*viscousU[i*viscousnumsteps+newindex]+lincoeff*viscousU[i*viscousnumsteps+newindex+1];
+			if(horiz){
+				viscousN[i*viscousnumsteps+newindex+offset]=(1-lincoeff)*viscousN[i*viscousnumsteps+newindex]+lincoeff*viscousN[i*viscousnumsteps+newindex+1];
+				viscousE[i*viscousnumsteps+newindex+offset]=(1-lincoeff)*viscousE[i*viscousnumsteps+newindex]+lincoeff*viscousE[i*viscousnumsteps+newindex+1];
+			}
+		}
+		viscousindex=newindex+offset;
+
+		this->parameters->SetParam(viscousindex,SealevelchangeViscousIndexEnum);
+		this->parameters->SetParam(viscoustimes,viscousnumsteps,SealevelchangeViscousTimesEnum);
+
+		/*free allocations:*/
+		xDelete<IssmDouble>(viscoustimes);
+	}
+
+}
+/*}}}*/
+void       Tria::SealevelchangeBarystaticLoads(GrdLoads* loads,  BarystaticContributions* barycontrib, SealevelGeometry* slgeom){ /*{{{*/
+
+	/*Inputs:*/
+	IssmDouble I[NUMVERTICES]; 
+	IssmDouble W[NUMVERTICES];
+	IssmDouble BP[NUMVERTICES];
+
+	/*output: */
+	IssmDouble bslcice=0;
+	IssmDouble bslchydro=0;
+	IssmDouble bslcbp=0;
+	IssmDouble BPavg=0;
+	IssmDouble Iavg=0;
+	IssmDouble Wavg=0;
+
+	/*ice properties: */
+	IssmDouble rho_ice,rho_water,rho_freshwater;
+
 	/*recover some parameters:*/
-	rho_ice=FindParam(MaterialsRhoIceEnum);
-	rho_water=FindParam(MaterialsRhoSeawaterEnum);
-	this->parameters->FindParam(&computerigid,SolidearthSettingsRigidEnum);
-	this->parameters->FindParam(&scaleoceanarea,SolidearthSettingsOceanAreaScalingEnum);
-	this->parameters->FindParam(&glfraction,SolidearthSettingsGlfractionEnum);
-
-	/*retrieve precomputed G:*/
-	if(computerigid)this->inputs->GetArrayPtr(SealevelriseGEnum,this->lid,&G,&gsize);
-
-	/*Get area of element: precomputed in the sealevelrise_core_geometry:*/
+	this->parameters->FindParam(&rho_ice,MaterialsRhoIceEnum);
+	this->parameters->FindParam(&rho_water,MaterialsRhoSeawaterEnum);
+	this->parameters->FindParam(&rho_freshwater,MaterialsRhoFreshwaterEnum);
+
+	/*Retrieve inputs:*/
+	Element::GetInputListOnVertices(&I[0],DeltaIceThicknessEnum);
+	Element::GetInputListOnVertices(&W[0],DeltaTwsEnum);
+	Element::GetInputListOnVertices(&BP[0],DeltaBottomPressureEnum);
+
+	for(int i=0;i<NUMVERTICES;i++){
+		Iavg+=I[i]*slgeom->LoadWeigths[SLGEOM_ICE][i][this->lid];
+		Wavg+=W[i]*slgeom->LoadWeigths[SLGEOM_WATER][i][this->lid];
+		BPavg+=BP[i]*slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid];
+	}
+
+	/*convert from m to kg/m^2:*/
+	Iavg*=rho_ice;
+	Wavg*=rho_freshwater;
+	BPavg*=rho_water;
+
+	#ifdef _ISSM_DEBUG_ 
+	this->AddInput(SealevelBarystaticIceLoadEnum,&Iavg,P0Enum);
+	this->AddInput(SealevelBarystaticHydroLoadEnum,&Wavg,P0Enum);
+	this->AddInput(SealevelBarystaticBpLoadEnum,&BPavg,P0Enum);
+	#endif
+
+	/*Compute barystatic component in kg:*/
+	bslcice =   -slgeom->LoadArea[SLGEOM_ICE][this->lid]*Iavg;
+	bslchydro = -slgeom->LoadArea[SLGEOM_WATER][this->lid]*Wavg;
+	bslcbp =    -slgeom->LoadArea[SLGEOM_OCEAN][this->lid]*BPavg;
+
+	_assert_(!xIsNan<IssmDouble>(bslcice));
+	_assert_(!xIsNan<IssmDouble>(bslchydro));
+	_assert_(!xIsNan<IssmDouble>(bslcbp));
+
+	/*Plug values into subelement load vector:*/
+	if(slgeom->issubelement[SLGEOM_ICE][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_ICE][this->lid];
+		loads->vsubloads[SLGEOM_ICE]->SetValue(intj,Iavg,INS_VAL);
+		Iavg=0; //avoid double counting centroid loads and subelement loads!
+	}
+	if(slgeom->issubelement[SLGEOM_WATER][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_WATER][this->lid];
+		loads->vsubloads[SLGEOM_WATER]->SetValue(intj,Wavg,INS_VAL);
+		Wavg=0;
+	}
+	if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
+		loads->vsubloads[SLGEOM_OCEAN]->SetValue(intj,BPavg,INS_VAL); 
+		BPavg=0;
+	}
+	/*Plug remaining values into centroi load vector:*/
+	loads->vloads->SetValue(this->sid,Iavg+Wavg+BPavg,INS_VAL);
+
+	/*Keep track of barystatic contributions:*/
+	barycontrib->Set(this->Sid(),bslcice,bslchydro,bslcbp);
+
+}
+/*}}}*/
+void       Tria::SealevelchangeConvolution(IssmDouble* sealevelpercpu, GrdLoads* loads, IssmDouble* polarmotionvector,SealevelGeometry* slgeom){ /*{{{*/
+
+	/*sal green function:*/
+	IssmDouble* G=NULL;
+	IssmDouble* Gsub[SLGEOM_NUMLOADS];
+	bool computefuture=false;
+
+	bool sal = false;
+	bool viscous = false;
+	bool rotation= false;
+	bool percpu= false;
+	int  size;
+	int  nel,nbar;
+	IssmDouble Grotm1[3];
+	IssmDouble Grotm2[3];
+	IssmDouble Grotm3[3];
+
+	this->parameters->FindParam(&sal,SolidearthSettingsSelfAttractionEnum);
+	this->parameters->FindParam(&viscous,SolidearthSettingsViscousEnum);
+	this->parameters->FindParam(&rotation,SolidearthSettingsRotationEnum);
+	this->parameters->FindParam(&nel,MeshNumberofelementsEnum);
+
+	if(sal){
+		this->inputs->GetArrayPtr(SealevelchangeGEnum,this->lid,&G,&size);
+		this->inputs->GetArrayPtr(SealevelchangeGsubelIceEnum,this->lid,&Gsub[SLGEOM_ICE],&size);
+		this->inputs->GetArrayPtr(SealevelchangeGsubelHydroEnum,this->lid,&Gsub[SLGEOM_WATER],&size);
+		this->inputs->GetArrayPtr(SealevelchangeGsubelOceanEnum,this->lid,&Gsub[SLGEOM_OCEAN],&size);
+
+		this->SealevelchangeGxL(sealevelpercpu, G, Gsub, loads, slgeom, nel,percpu=true,SealevelchangeViscousRSLEnum,computefuture=false);
+	}
+
+	if(rotation){
+		Element::GetInputListOnVertices(&Grotm1[0],SealevelGrotm1Enum);
+		Element::GetInputListOnVertices(&Grotm2[0],SealevelGrotm2Enum);
+		Element::GetInputListOnVertices(&Grotm3[0],SealevelGrotm3Enum);
+
+		for(int i=0;i<NUMVERTICES;i++){
+			if(slgeom->lids[this->vertices[i]->lid]==this->lid){
+				sealevelpercpu[this->vertices[i]->lid]+=Grotm1[i]*polarmotionvector[0]+Grotm2[i]*polarmotionvector[1]+Grotm3[i]*polarmotionvector[2];
+			}
+		}
+	}
+	return;
+} /*}}}*/
+void       Tria::SealevelchangeOceanAverage(GrdLoads* loads, Vector<IssmDouble>* oceanareas, Vector<IssmDouble>* subelementoceanareas, IssmDouble* sealevelpercpu, SealevelGeometry* slgeom){ /*{{{*/
+
+	/*sal green function:*/
+	IssmDouble oceanaverage=0;
+	IssmDouble oceanarea=0;
+	IssmDouble rho_water;
+
+	this->parameters->FindParam(&rho_water,MaterialsRhoSeawaterEnum);
+
+	/*retrieve ocean average and area:*/
+	for(int i=0;i<NUMVERTICES;i++){
+		oceanaverage+=sealevelpercpu[this->vertices[i]->lid]*slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid];
+	}
+	#ifdef _ISSM_DEBUG_ 
+	this->AddInput(SealevelBarystaticOceanLoadEnum,&oceanaverage,P0Enum);
+	#endif
+	oceanarea=slgeom->LoadArea[SLGEOM_OCEAN][this->lid];
+
+	/*add ocean average in the global sealevelloads vector:*/
+	if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
+		loads->vsubsealevelloads->SetValue(intj,oceanaverage*rho_water,INS_VAL);
+		loads->vsealevelloads->SetValue(this->sid,0.,INS_VAL);
+	}
+	else loads->vsealevelloads->SetValue(this->sid,oceanaverage*rho_water,INS_VAL);
+
+	/*add ocean area into a global oceanareas vector:*/
+	if(!loads->sealevelloads){
+		oceanareas->SetValue(this->sid,oceanarea,INS_VAL);
+		if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
+			int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
+			subelementoceanareas->SetValue(intj,oceanarea,INS_VAL);
+		}
+	}
+
+	return;
+} /*}}}*/
+void       Tria::SealevelchangeDeformationConvolution(IssmDouble* sealevelpercpu, GrdLoads* loads, IssmDouble* polarmotionvector,SealevelGeometry* slgeom){ /*{{{*/
+
+	IssmDouble SealevelGrd[3]={0,0,0};
+	IssmDouble RSLGrd[3]={0,0,0};
+	IssmDouble UGrd[3]={0,0,0};
+	IssmDouble NGrd[3]={0,0,0};
+	IssmDouble EGrd[3]={0,0,0};
+	int nel,nbar;
+	bool sal = false;
+	IssmDouble* G=NULL;
+	IssmDouble* GU=NULL;
+	IssmDouble* GE=NULL;
+	IssmDouble* GN=NULL;
+	IssmDouble* Gsub[SLGEOM_NUMLOADS];
+	IssmDouble* GUsub[SLGEOM_NUMLOADS];
+	IssmDouble* GNsub[SLGEOM_NUMLOADS];
+	IssmDouble* GEsub[SLGEOM_NUMLOADS];
+	bool computefuture=false;
+
+	int horiz;
+	int size;
+	IssmDouble Grotm1[3];
+	IssmDouble Grotm2[3];
+	IssmDouble Grotm3[3];
+	IssmDouble GUrotm1[3];
+	IssmDouble GUrotm2[3];
+	IssmDouble GUrotm3[3];
+	IssmDouble GNrotm1[3];
+	IssmDouble GNrotm2[3];
+	IssmDouble GNrotm3[3];
+	IssmDouble GErotm1[3];
+	IssmDouble GErotm2[3];
+	IssmDouble GErotm3[3];
+	bool rotation= false;
+	bool elastic=false;
+	bool percpu=false;
+	bool planethasocean=false;
+
+	this->parameters->FindParam(&nel,MeshNumberofelementsEnum);
+	this->parameters->FindParam(&sal,SolidearthSettingsSelfAttractionEnum);
+	this->parameters->FindParam(&rotation,SolidearthSettingsRotationEnum);
+	this->parameters->FindParam(&elastic,SolidearthSettingsElasticEnum);
+	this->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
+	this->parameters->FindParam(&planethasocean,SolidearthSettingsGrdOceanEnum);
+
+	if(sal){
+
+		this->inputs->GetArrayPtr(SealevelchangeGEnum,this->lid,&G,&size);
+		this->inputs->GetArrayPtr(SealevelchangeGsubelIceEnum,this->lid,&Gsub[SLGEOM_ICE],&size);
+		this->inputs->GetArrayPtr(SealevelchangeGsubelHydroEnum,this->lid,&Gsub[SLGEOM_WATER],&size);
+		this->inputs->GetArrayPtr(SealevelchangeGsubelOceanEnum,this->lid,&Gsub[SLGEOM_OCEAN],&size);
+
+		if(elastic){
+			this->inputs->GetArrayPtr(SealevelchangeGUEnum,this->lid,&GU,&size);
+			this->inputs->GetArrayPtr(SealevelchangeGUsubelIceEnum,this->lid,&GUsub[SLGEOM_ICE],&size);
+			this->inputs->GetArrayPtr(SealevelchangeGUsubelHydroEnum,this->lid,&GUsub[SLGEOM_WATER],&size);
+			this->inputs->GetArrayPtr(SealevelchangeGUsubelOceanEnum,this->lid,&GUsub[SLGEOM_OCEAN],&size);
+			if(horiz){
+				this->inputs->GetArrayPtr(SealevelchangeGNEnum,this->lid,&GN,&size);
+				this->inputs->GetArrayPtr(SealevelchangeGNsubelIceEnum,this->lid,&GNsub[SLGEOM_ICE],&size);
+				this->inputs->GetArrayPtr(SealevelchangeGNsubelHydroEnum,this->lid,&GNsub[SLGEOM_WATER],&size);
+				this->inputs->GetArrayPtr(SealevelchangeGNsubelOceanEnum,this->lid,&GNsub[SLGEOM_OCEAN],&size);
+
+				this->inputs->GetArrayPtr(SealevelchangeGEEnum,this->lid,&GE,&size);
+				this->inputs->GetArrayPtr(SealevelchangeGEsubelIceEnum,this->lid,&GEsub[SLGEOM_ICE],&size);
+				this->inputs->GetArrayPtr(SealevelchangeGEsubelHydroEnum,this->lid,&GEsub[SLGEOM_WATER],&size);
+				this->inputs->GetArrayPtr(SealevelchangeGEsubelOceanEnum,this->lid,&GEsub[SLGEOM_OCEAN],&size);
+			}
+		}
+		this->SealevelchangeGxL(&RSLGrd[0],G, Gsub, loads, slgeom, nel,percpu=false,SealevelchangeViscousRSLEnum,computefuture=true);
+
+		if(elastic){
+			this->SealevelchangeGxL(&UGrd[0],GU, GUsub, loads, slgeom, nel,percpu=false,SealevelchangeViscousUEnum,computefuture=true);
+			if(horiz ){
+				this->SealevelchangeGxL(&NGrd[0],GN, GNsub, loads, slgeom, nel,percpu=false,SealevelchangeViscousNEnum,computefuture=true);
+				this->SealevelchangeGxL(&EGrd[0],GE, GEsub, loads, slgeom, nel,percpu=false,SealevelchangeViscousEEnum,computefuture=true);
+			}
+		}
+	}
+
+	if(rotation){
+		Element::GetInputListOnVertices(&Grotm1[0],SealevelGrotm1Enum);
+		Element::GetInputListOnVertices(&Grotm2[0],SealevelGrotm2Enum);
+		Element::GetInputListOnVertices(&Grotm3[0],SealevelGrotm3Enum);
+
+		for(int i=0;i<NUMVERTICES;i++){
+			if(slgeom->lids[this->vertices[i]->lid]==this->lid){
+				RSLGrd[i]+=Grotm1[i]*polarmotionvector[0]+Grotm2[i]*polarmotionvector[1]+Grotm3[i]*polarmotionvector[2];
+			}
+		}
+
+		if (elastic){
+			Element::GetInputListOnVertices(&GUrotm1[0],SealevelGUrotm1Enum);
+			Element::GetInputListOnVertices(&GUrotm2[0],SealevelGUrotm2Enum);
+			Element::GetInputListOnVertices(&GUrotm3[0],SealevelGUrotm3Enum);
+
+			for(int i=0;i<NUMVERTICES;i++){
+				if(slgeom->lids[this->vertices[i]->lid]==this->lid){
+					UGrd[i]+=GUrotm1[i]*polarmotionvector[0]+GUrotm2[i]*polarmotionvector[1]+GUrotm3[i]*polarmotionvector[2];
+				}
+			}
+			if (horiz){
+				Element::GetInputListOnVertices(&GNrotm1[0],SealevelGNrotm1Enum);
+				Element::GetInputListOnVertices(&GNrotm2[0],SealevelGNrotm2Enum);
+				Element::GetInputListOnVertices(&GNrotm3[0],SealevelGNrotm3Enum);
+				Element::GetInputListOnVertices(&GErotm1[0],SealevelGErotm1Enum);
+				Element::GetInputListOnVertices(&GErotm2[0],SealevelGErotm2Enum);
+				Element::GetInputListOnVertices(&GErotm3[0],SealevelGErotm3Enum);
+
+				for(int i=0;i<NUMVERTICES;i++){
+					if(slgeom->lids[this->vertices[i]->lid]==this->lid){
+						NGrd[i]+=GNrotm1[i]*polarmotionvector[0]+GNrotm2[i]*polarmotionvector[1]+GNrotm3[i]*polarmotionvector[2];
+						EGrd[i]+=GErotm1[i]*polarmotionvector[0]+GErotm2[i]*polarmotionvector[1]+GErotm3[i]*polarmotionvector[2];
+					}
+				}
+			}
+		}
+	}
+
+	if (planethasocean){ //We must also output the RSL on vertices to compute the ocean mass conservation
+		for(int i=0;i<NUMVERTICES;i++){
+			if(slgeom->lids[this->vertices[i]->lid]==this->lid){
+				sealevelpercpu[this->vertices[i]->lid]=RSLGrd[i];
+			}
+		}
+	}
+
+	/*Create geoid: */
+	for(int i=0;i<NUMVERTICES;i++)SealevelGrd[i]=UGrd[i]+RSLGrd[i];
+
+	/*Create inputs*/
+	this->AddInput(SealevelGRDEnum,SealevelGrd,P1Enum);
+	this->AddInput(BedGRDEnum,UGrd,P1Enum);
+	if(horiz){
+		this->AddInput(BedNorthGRDEnum,NGrd,P1Enum);
+		this->AddInput(BedEastGRDEnum,EGrd,P1Enum);
+	}
+
+} /*}}}*/
+void       Tria::SealevelchangeGxL(IssmDouble* grdfieldout, IssmDouble* G, IssmDouble** Gsub, GrdLoads* loads, SealevelGeometry* slgeom, int nel, bool percpu, int viscousenum, bool computefuture) { /*{{{*/
+
+	IssmDouble* grdfield=NULL;
+	int i,e,l,t,nbar;
+	bool computeviscous=false;
+	IssmDouble* viscousfield=NULL;
+	int nt=1; //important
+	int viscousindex=0; //important
+	int viscousnumsteps=1; //important
+
+	this->parameters->FindParam(&computeviscous,SolidearthSettingsViscousEnum);
+	if(computeviscous){
+		this->parameters->FindParam(&viscousnumsteps,SealevelchangeViscousNumStepsEnum);
+		if(computefuture) nt=viscousnumsteps;
+		else nt=1;
+
+		//allocate
+		grdfield=xNewZeroInit<IssmDouble>(3*nt);
+	}
+	else grdfield=xNewZeroInit<IssmDouble>(3*nt);
+
+	if(loads->sealevelloads){
+
+		for(i=0;i<NUMVERTICES;i++) {
+			if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
+			for (e=0;e<nel;e++){
+				for(t=0;t<nt;t++){
+					int index=i*nel*viscousnumsteps+e*viscousnumsteps+t;
+					grdfield[i*nt+t]+=G[index]*(loads->sealevelloads[e]+loads->loads[e]);
+				}
+			}
+			for(l=0;l<SLGEOM_NUMLOADS;l++){
+				nbar=slgeom->nbar[l];
+				for (e=0;e<nbar;e++){
+					for(t=0;t<nt;t++){
+						int index=i*nbar*viscousnumsteps+e*viscousnumsteps+t;
+						grdfield[i*nt+t]+=Gsub[l][index]*(loads->subloads[l][e]);
+					}
+				}
+				if(l==SLGEOM_OCEAN){
+					for (e=0;e<nbar;e++){
+						for(t=0;t<nt;t++){
+							int index=i*nbar*viscousnumsteps+e*viscousnumsteps+t;
+							grdfield[i*nt+t]+=Gsub[l][index]*(loads->subsealevelloads[e]);
+						}
+					}
+				}
+			}
+		}
+	}
+	else{  //this is the initial convolution where only loads are provided
+
+		for(i=0;i<NUMVERTICES;i++) {
+			if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
+			for (e=0;e<nel;e++){
+				for(t=0;t<nt;t++){
+					int index=i*nel*viscousnumsteps+e*viscousnumsteps+t;
+					grdfield[i*nt+t]+=G[index]*(loads->loads[e]);
+				}
+			}
+			for(l=0;l<SLGEOM_NUMLOADS;l++){
+				nbar=slgeom->nbar[l];
+				for (e=0;e<nbar;e++){
+					for(t=0;t<nt;t++){
+						int index=i*nbar*viscousnumsteps+e*viscousnumsteps+t;
+						grdfield[i*nt+t]+=Gsub[l][index]*(loads->subloads[l][e]);
+					}
+				}
+			}
+		}
+	}
+
+	if(computeviscous){
+		IssmDouble* grdfieldinterp=NULL;
+		IssmDouble* viscoustimes=NULL;
+		IssmDouble  final_time;
+		IssmDouble  lincoeff;
+		IssmDouble  timeacc;
+
+		this->parameters->FindParam(&viscousindex,SealevelchangeViscousIndexEnum);
+		this->parameters->FindParam(&viscoustimes,NULL,SealevelchangeViscousTimesEnum);
+		this->parameters->FindParam(&final_time,TimesteppingFinalTimeEnum);
+		this->parameters->FindParam(&timeacc,SolidearthSettingsTimeAccEnum);
+		this->inputs->GetArrayPtr(viscousenum,this->lid,&viscousfield,NULL);
+		if(computefuture){
+			grdfieldinterp=xNew<IssmDouble>(3*nt); 
+			if(viscoustimes[viscousindex]<final_time){
+				lincoeff=(viscoustimes[viscousindex+1]-viscoustimes[viscousindex])/timeacc;
+				for(int t=viscousindex;t<nt;t++){
+					if(t==viscousindex){
+						for(int i=0;i<NUMVERTICES;i++){
+							if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
+							grdfieldinterp[i*nt+t]=  grdfield[i*nt+0];
+						}
+					}
+					else{
+						for(int i=0;i<NUMVERTICES;i++){
+							if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
+							grdfieldinterp[i*nt+t]=  (1-lincoeff)*grdfield[i*nt+(t-viscousindex-1)]+lincoeff*grdfield[i*nt+(t-viscousindex)];
+						}
+					}
+				}
+			}
+		}
+
+		/*update grdfield at present time using viscous stack at present time: */
+		for(int i=0;i<NUMVERTICES;i++){
+			if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
+			grdfield[i*nt+0]+=viscousfield[i*viscousnumsteps+viscousindex]; 
+		}
+
+		if(computefuture){ /*update viscous stack with future deformation from present load: */
+
+			for(int t=nt-1;t>=viscousindex;t--){
+				for(int i=0;i<NUMVERTICES;i++){
+					if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
+					//offset viscousfield to remove all deformation that has already been added
+					viscousfield[i*viscousnumsteps+t]+=grdfieldinterp[i*nt+t]-grdfieldinterp[i*nt+viscousindex]-viscousfield[i*viscousnumsteps+viscousindex];
+				}
+			}
+			/*Re-add viscous stack now that we updated:*/
+			this->inputs->SetArrayInput(viscousenum,this->lid,viscousfield,3*viscousnumsteps);
+		}
+
+		/*Free allocatoins:*/
+		xDelete<IssmDouble>(viscoustimes);
+	}
+
+	/*store values computed on vertices, but don't repeat the computation if another element already computed it!:*/
+	if(percpu){
+		for(i=0;i<NUMVERTICES;i++){
+			if(slgeom->lids[this->vertices[i]->lid]==this->lid){
+				grdfieldout[this->vertices[i]->lid]=grdfield[i*nt+0];
+			}
+		}
+	}
+	else{
+		for(i=0;i<NUMVERTICES;i++) grdfieldout[i]=grdfield[i*nt+0];
+	}
+
+} /*}}}*/
+void       Tria::SealevelchangeMomentOfInertiaCentroid(IssmDouble* dI_list, GrdLoads* loads, SealevelGeometry* slgeom){/*{{{*/
+
+	IssmDouble S=0;
+
+	/*Compute area of element:*/
+	IssmDouble area,planetarea,re;
+	IssmDouble late,longe;
 	this->Element::GetInputValue(&area,AreaEnum);
 
-	/*Compute fraction of the element that is grounded: */
-	if(notfullygrounded){
-		IssmDouble xyz_list[NUMVERTICES][3];
-		::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-
-		phi=this->GetGroundedPortion(&xyz_list[0][0]); //watch out, this only works because of the Thales theorem! We are in 3D, but this routine is inherently for 2D trias
-		if(glfraction==0)phi=1;
-		#ifdef _ISSM_DEBUG_
-		this->AddInput(SealevelEustaticMaskEnum,&phi,P0Enum);
-		#endif
-	}
-	else phi=1.0;
-
-	/*Retrieve ice thickness at vertices: */
-	Input* deltathickness_input=this->GetInput(SurfaceloadIceThicknessChangeEnum);
-	if (!deltathickness_input)_error_("delta thickness input needed to compute sea level rise!");
-
-	/*/Average ice thickness over grounded area of the element only: {{{*/
-	if(!notfullygrounded)deltathickness_input->GetInputAverage(&I);
-	else{
-		IssmDouble total_weight=0;
-		bool mainlyfloating = true;
-		int         point1;
-		IssmDouble  fraction1,fraction2;
-
-		/*Recover portion of element that is grounded*/
-		this->GetGroundedPart(&point1,&fraction1,&fraction2,&mainlyfloating);
-		Gauss* gauss = this->NewGauss(point1,fraction1,fraction2,mainlyfloating,2);
-
-		/* Start  looping on the number of gaussian points and average over these gaussian points: */
-		total_weight=0;
-		I=0;
-		while(gauss->next()){
-			IssmDouble Ig=0;
-			deltathickness_input->GetInputValue(&Ig,gauss);
-			I+=Ig*gauss->weight;
-			total_weight+=gauss->weight;
-		}
-		I=I/total_weight;
-		delete gauss;
-	}
-	/*}}}*/
-
-	/*Compute barystatic contribution:*/
-	_assert_(oceanarea>0.);
-	if(scaleoceanarea) oceanarea=3.619e+14; // use true ocean area, m^2
-	bslrice = rho_ice*area*phi*I/(oceanarea*rho_water);
-	_assert_(!xIsNan<IssmDouble>(bslrice));
-
-	if(computerigid){
-		/*convert from m to kg/m^2:*/
-		I=I*rho_ice*phi;
-
-		/*convolve:*/
-		for(int i=0;i<gsize;i++) Sgi[i]+=G[i]*I;
-	}
-
-	/*Plug bslrice into barystatic contribution vector:*/
-	if(barystatic_contribution){
-		id=reCast<int>(partition[this->Sid()])+1;
-		barystatic_contribution->SetValue(id,bslrice,ADD_VAL);
-	}
-	/*return :*/
-	return bslrice;
-}
-/*}}}*/
-IssmDouble Tria::SealevelriseEustaticHydro(IssmDouble* Sgi, SealevelMasks* masks, Vector<IssmDouble>* barystatic_contribution, IssmDouble* partition, IssmDouble oceanarea){ /*{{{*/
-
-	/*diverse:*/
-	int gsize;
-	IssmDouble area;
-	IssmDouble phi=1.0; //WARNING: do not touch this, default is entire elemnt contributes barystatic
-	IssmDouble W;  //change in water height thickness (Farrel and Clarke, Equ. 4)
-	bool notfullygrounded=false;
-	bool scaleoceanarea= false;
-	bool computeelastic= false;
-
-	/*elastic green function:*/
-	IssmDouble* G=NULL;
-
-	/*ice properties: */
-	IssmDouble rho_water;
-	IssmDouble rho_freshwater;
-
-	/*output:*/
-	IssmDouble bslrhydro = 0;
-
-	/*early return if we are on an ice cap. Nop, we may have hydro
-	 * and ice on the same masscon:*/
-	/*if(masks->isiceonly[this->lid]){ 
-		bslrhydro=0;
-		return bslrhydro; 
-	}*/
-
-	/*early return if we are fully floating:*/
-	if (masks->isfullyfloating[this->lid]){ 
-		bslrhydro=0;
-		return bslrhydro; 
-	}
-
-	/*If we are here, we are on earth, not on ice: */
-
 	/*recover parameters: */
-	rho_water=FindParam(MaterialsRhoSeawaterEnum);
-	rho_freshwater=FindParam(MaterialsRhoFreshwaterEnum);
-	this->parameters->FindParam(&computeelastic,SolidearthSettingsElasticEnum);
-	this->parameters->FindParam(&scaleoceanarea,SolidearthSettingsOceanAreaScalingEnum);
-
-	/*retrieve precomputed G:*/
-	if(computeelastic)this->inputs->GetArrayPtr(SealevelriseGEnum,this->lid,&G,&gsize);
-
-	/*Get area of element: precomputed in the sealevelrise_core_geometry:*/
-	this->Element::GetInputValue(&area,AreaEnum);
-
-	/*Retrieve water height at vertices: */
-	Input* deltathickness_input=this->GetInput(SurfaceloadWaterHeightChangeEnum);
-	if (!deltathickness_input)_error_("SurfaceloadWaterHeightChangeEnum input needed to compute sea level rise!");
-	deltathickness_input->GetInputAverage(&W);
-
-	/*Compute barystatic component:*/
-	_assert_(oceanarea>0.);
-	if(scaleoceanarea) oceanarea=3.619e+14; // use true ocean area, m^2
-	bslrhydro = rho_freshwater*area*phi*W/(oceanarea*rho_water);
-	_assert_(!xIsNan<IssmDouble>(bslrhydro));
-
-	if(computeelastic){
-		/*convert from m to kg/m^2:*/
-		W=W*rho_freshwater*phi;
-
-		/*convolve:*/
-		for(int i=0;i<gsize;i++) Sgi[i]+=G[i]*W;
-	}
-
-	/*Plug bslrice into barystatic contribution vector:*/
-	if(barystatic_contribution){
-		id=reCast<int>(partition[this->Sid()])+1;
-		barystatic_contribution->SetValue(id,bslrhydro,ADD_VAL);
-	}
-	/*output:*/
-	return bslrhydro;
-}
-/*}}}*/
-void    Tria::SealevelriseEustaticBottomPressure(IssmDouble* Sgi,SealevelMasks* masks){ /*{{{*/
-
-	/*diverse:*/
-	int gsize;
-	IssmDouble area;
-	IssmDouble BP;  //change in bottom pressure (Farrel and Clarke, Equ. 4)
-	IssmDouble constant;
-	bool computeelastic= false;
-
-	/*elastic green function:*/
-	IssmDouble* G=NULL;
-
-	/*water properties: */
-	IssmDouble rho_water;
-
-	/*exit now?:*/
-	this->parameters->FindParam(&computeelastic,SolidearthSettingsElasticEnum);
-	if(!computeelastic)return;
-
-	/*we are here to compute fingerprints originating fromn bottom pressure changes:*/
-	if(!masks->isoceanin[this->lid])return;
-
-	/*Inform mask: */
-	#ifdef _ISSM_DEBUG_
-	constant=1; this->AddInput(SealevelEustaticMaskEnum,&constant,P0Enum);
-	#endif
-
-	/*recover material parameters: */
-	rho_water=FindParam(MaterialsRhoSeawaterEnum);
-
-	/*retrieve precomputed G:*/
-	this->inputs->GetArrayPtr(SealevelriseGEnum,this->lid,&G,&gsize);
-
-	/*Get area of element: precomputed in the sealevelrise_core_geometry:*/
-	this->Element::GetInputValue(&area,AreaEnum);
-
-	/*Retrieve bottom pressure change and average over the element: */
-	Input* bottompressure_change_input=this->GetInput(DslSeaWaterPressureChangeAtSeaFloorEnum);
-	if (!bottompressure_change_input)_error_("bottom pressure input needed to compute sea level rise fingerprint!");
-	bottompressure_change_input->GetInputAverage(&BP);
-
-	/*convert from m to kg/m^2:*/
-	BP=BP*rho_water;
-
-	/*convolve:*/
-	for(int i=0;i<gsize;i++) Sgi[i]+=G[i]*BP;
-
+	this->parameters->FindParam(&planetarea,SolidearthPlanetAreaEnum);
+	this->parameters->FindParam(&re,SolidearthPlanetRadiusEnum);
+	late=slgeom->late[this->lid]/180*M_PI;
+	longe=slgeom->longe[this->lid]/180*M_PI;
+
+	/*recover total load: */
+	if(loads->loads) S+=loads->loads[this->Sid()];
+	if(loads->sealevelloads) S+=loads->sealevelloads[this->Sid()];
+
+	/* Perturbation terms for moment of inertia (moi_list):
+	 * computed analytically (see Wu & Peltier, eqs 10 & 32)
+	 * also consistent with my GMD formulation!
+	 * ALL in geographic coordinates
+	 * */
+	dI_list[0] = -4*M_PI*(S*area)*pow(re,4)*(sin(late)*cos(late)*cos(longe))/planetarea;
+	dI_list[1] = -4*M_PI*(S*area)*pow(re,4)*(sin(late)*cos(late)*sin(longe))/planetarea;
+	dI_list[2] = +4*M_PI*(S*area)*pow(re,4)*(1-pow(sin(late),2))/planetarea;
 	return;
-}
-/*}}}*/
-void    Tria::SealevelriseNonEustatic(IssmDouble* Sgo,IssmDouble* Sg_old, SealevelMasks* masks){ /*{{{*/
-
-	/*diverse:*/
-	int gsize,dummy;
-	IssmDouble S;  //change in water water level(Farrel and Clarke, Equ. 4)
-	IssmDouble constant=0;
-	IssmDouble rho_water;
-	IssmDouble* G=NULL;
-	int  bp_compute_fingerprints= 0;
-
-	/*retrieve parameters:*/
-	this->parameters->FindParam(&bp_compute_fingerprints,DslComputeFingerprintsEnum);
-	rho_water=FindParam(MaterialsRhoSeawaterEnum);
-
-	/*early return if we are not on the ocean:*/
-	if (!masks->isoceanin[this->lid]){
-		constant=0;
-		#ifdef _ISSM_DEBUG_
-		this->AddInput(SealevelEustaticOceanMaskEnum,&constant,P0Enum);
-		#endif
-		return;
-	}
-	constant=1;
-	#ifdef _ISSM_DEBUG_
-	this->AddInput(SealevelEustaticOceanMaskEnum,&constant,P0Enum);
-	#endif
-
-	/*how many dofs are we working with here? */
-	this->parameters->FindParam(&gsize,MeshNumberofverticesEnum);
-
-	/*retrieve precomputed G:*/
-	this->inputs->GetArrayPtr(SealevelriseGEnum,this->lid,&G,&dummy); _assert_(dummy==gsize);
-
-	/*From Sg_old, recover water sea level rise:*/
-	S=0; for(int i=0;i<NUMVERTICES;i++) S+=Sg_old[this->vertices[i]->Sid()]/NUMVERTICES;
-
-	/*convert to kg/m^2: */
-	S=S*rho_water;
-
-	for(int i=0;i<gsize;i++) Sgo[i]+=G[i]*S;
+}/*}}}*/
+void       Tria::SealevelchangeMomentOfInertiaSubElement(IssmDouble* dI_list, GrdLoads* grdloads,  SealevelGeometry* slgeom){/*{{{*/
+
+	IssmDouble  SA=0;
+	IssmDouble* loads=NULL;
+	IssmDouble* sealevelloads=NULL;
+	IssmDouble  late,longe,re;
+	int         intj;
+	IssmDouble  area;
+	IssmDouble  planetarea;
+
+	/*recover parameters: */
+	this->parameters->FindParam(&planetarea,SolidearthPlanetAreaEnum);
+	this->parameters->FindParam(&re,SolidearthPlanetRadiusEnum);
+
+	/*Initalize:*/
+	for(int i=0;i<3;i++)dI_list[i]=0;
+
+	/*Go through our loads:*/
+	for(int i=0;i<SLGEOM_NUMLOADS;i++){
+		if(slgeom->issubelement[i][this->lid]){
+			loads=grdloads->subloads[i];
+			if(i==SLGEOM_OCEAN) sealevelloads=grdloads->subsealevelloads;
+			intj=slgeom->subelementmapping[i][this->lid];
+			late=slgeom->latbarycentre[i][intj]/180*M_PI;
+			longe=slgeom->longbarycentre[i][intj]/180*M_PI;
+			area=slgeom->area_subel[i][intj];
+
+			/*recover total load: */
+			if(loads) SA+=loads[intj]*area;
+			if(sealevelloads) SA+=sealevelloads[intj]*area;
+		}
+	}
+
+	/* Perturbation terms for moment of inertia (moi_list):
+	 * computed analytically (see Wu & Peltier, eqs 10 & 32)
+	 * also consistent with my GMD formulation!
+	 * ALL in geographic coordinates
+	 * */
+	dI_list[0] += -4*M_PI*(SA)*pow(re,4)*(sin(late)*cos(late)*cos(longe))/planetarea;
+	dI_list[1] += -4*M_PI*(SA)*pow(re,4)*(sin(late)*cos(late)*sin(longe))/planetarea;
+	dI_list[2] += +4*M_PI*(SA)*pow(re,4)*(1-pow(sin(late),2))/planetarea;
 
 	return;
-}
-/*}}}*/
-void    Tria::SealevelriseGeodetic(IssmDouble* Up, IssmDouble* North ,IssmDouble* East,IssmDouble* Sg, SealevelMasks* masks){ /*{{{*/
-
-	/*diverse:*/
-	int gsize;
-	IssmDouble I, S, BP;		//change in relative ice thickness and sea level
-	IssmDouble rho_ice,rho_water;
-	int horiz;
-	int  bp_compute_fingerprints= 0;
-
-	/*precomputed elastic green functions:*/
-	IssmDouble* GU=NULL;
-	IssmDouble* GN=NULL;
-	IssmDouble* GE=NULL;
-
-	/*computational flags:*/
-	bool computeelastic= false;
-
-	/*early return if we are not on the ocean or on an ice cap:*/
-	if(!masks->isiceonly[this->lid] && !masks->isoceanin[this->lid]) return;
-
-	/*recover parameters:*/
-	this->parameters->FindParam(&computeelastic,SolidearthSettingsElasticEnum);
-	this->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
-	this->parameters->FindParam(&bp_compute_fingerprints,DslComputeFingerprintsEnum);
-
-	/*early return if elastic not requested:*/
-	if(!computeelastic) return;
-
-	/*recover material parameters: */
-	rho_ice=FindParam(MaterialsRhoIceEnum);
-	rho_water=FindParam(MaterialsRhoSeawaterEnum);
-
-	/*recover elastic Green's functions for displacement:*/
-	this->inputs->GetArrayPtr(SealevelriseGUEnum,this->lid,&GU,&gsize);
-	if(horiz){
-		this->inputs->GetArrayPtr(SealevelriseGEEnum,this->lid,&GE,&gsize);
-		this->inputs->GetArrayPtr(SealevelriseGNEnum,this->lid,&GN,&gsize);
-	}
-
-
-	if(masks->isoceanin[this->lid]){
-		/*From Sg, recover water sea level rise:*/
-		S=0; for(int i=0;i<NUMVERTICES;i++) S+=Sg[this->vertices[i]->Sid()]/NUMVERTICES;
-
-		/*convert to kg/m^2:*/
-		S=rho_water*S;
-		
-		/*If bottom pressures are available, retrieve them to load the bedrock:*/
-		if(bp_compute_fingerprints){
-			Input* bottompressure_change_input=this->GetInput(DslSeaWaterPressureChangeAtSeaFloorEnum);
-			if (!bottompressure_change_input)_error_("bottom pressure input needed to compute sea level rise fingerprint!");
-			bottompressure_change_input->GetInputAverage(&BP);
-
-			/*convert from m to kg/m^2:*/
-			BP=BP*rho_water;
-
-			S+=BP;
-		}
-
-		for(int i=0;i<gsize;i++){
-			Up[i]+=S*GU[i];
-			if(horiz){
-				North[i]+=S*GN[i];
-				East[i]+=S*GE[i];
-			}
-		}
-	}
-	else if (masks->isiceonly[this->lid]){
-
-		/*Compute ice thickness change: */
-		Input* deltathickness_input=this->GetInput(SurfaceloadIceThicknessChangeEnum);
-		if (!deltathickness_input)_error_("delta thickness input needed to compute sea level rise!");
-		deltathickness_input->GetInputAverage(&I);
-
-		/*convert to kg/m^2*/
-		I=I*rho_ice;
-
-		for(int i=0;i<gsize;i++){
-			Up[i]+=I*GU[i];
-			if(horiz){
-				North[i]+=I*GN[i];
-				East[i]+=I*GE[i];
-			}
-		}
-	}
-
-	return;
-}
-/*}}}*/
+}/*}}}*/
+void       Tria::SealevelchangeShift(GrdLoads* loads,  IssmDouble offset, SealevelGeometry* slgeom){ /*{{{*/
+
+	if(slgeom->isoceanin[this->lid]){
+		if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
+			int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
+			loads->vsubsealevelloads->SetValue(intj,offset,ADD_VAL);
+		}
+		else loads->vsealevelloads->SetValue(this->sid,offset,ADD_VAL);
+	}
+
+} /*}}}*/
 #endif
 
